// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a menu item.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.MenuCommandTagDeclaration}.
 */
public class UIMenuCommand
    extends UICommand  {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.MenuCommand";

  private java.lang.Character accessKey;
  private java.lang.String labelWithAccessKey;
  private java.lang.Boolean jsfResource;
  private java.lang.String image;
  private java.lang.Boolean transition;
  private java.lang.String label;
  private java.lang.Boolean immediate;
  private java.lang.Boolean disabled;


  /**
  Deprecated! Has not longer any function.

  @deprecated*/
  @Deprecated
  public java.lang.Character getAccessKey() {
    if (accessKey != null) {
      return accessKey;
    }
    ValueExpression ve = getValueExpression("accessKey");
    if (ve != null) {
      try {
        return (java.lang.Character) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setAccessKey(java.lang.Character accessKey) {
    this.accessKey = accessKey;
  }

  /**
  Deprecated! Use 'label' instead.
   Text value to display as label.
   If text contains an underscore the next character overwrites 'accesskey'.

  @deprecated*/
  @Deprecated
  public java.lang.String getLabelWithAccessKey() {
    if (labelWithAccessKey != null) {
      return labelWithAccessKey;
    }
    ValueExpression ve = getValueExpression("labelWithAccessKey");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  @Deprecated
  public void setLabelWithAccessKey(java.lang.String labelWithAccessKey) {
    this.labelWithAccessKey = labelWithAccessKey;
  }

  /**
  Flag indicating that the resource referenced by the resource attribute is a jsf resource.
   That means that the url has to be processed to change the prefix or suffix (e. g. *.jsf or
   /faces/*). Default is false.
  <br />Default: <code>false</code>
  */
  public boolean isJsfResource() {
    if (jsfResource != null) {
      return jsfResource;
    }
    ValueExpression ve = getValueExpression("jsfResource");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setJsfResource(boolean jsfResource) {
    this.jsfResource = jsfResource;
  }

  /**
  Url to an image to display.

  */
  public java.lang.String getImage() {
    if (image != null) {
      return image;
    }
    ValueExpression ve = getValueExpression("image");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setImage(java.lang.String image) {
    this.image = image;
  }

  /**
  Specify, if the command calls an JSF-Action.
   Useful to switch off the Double-Submit-Check and Waiting-Behavior.
  <br />Default: <code>true</code>
  */
  public boolean isTransition() {
    if (transition != null) {
      return transition;
    }
    ValueExpression ve = getValueExpression("transition");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setTransition(boolean transition) {
    this.transition = transition;
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey.

  */
  public java.lang.String getLabel() {
    if (label != null) {
      return label;
    }
    ValueExpression ve = getValueExpression("label");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLabel(java.lang.String label) {
    this.label = label;
  }

  /**
  Flag indicating that, if this component is activated by the user,
   notifications should be delivered to interested listeners and actions
   immediately (that is, during Apply Request Values phase) rather than
   waiting until Invoke Application phase.
  <br />Default: <code>false</code>
  */
  public boolean isImmediate() {
    if (immediate != null) {
      return immediate;
    }
    ValueExpression ve = getValueExpression("immediate");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setImmediate(boolean immediate) {
    this.immediate = immediate;
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    if (disabled != null) {
      return disabled;
    }
    ValueExpression ve = getValueExpression("disabled");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    this.disabled = disabled;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    accessKey = (java.lang.Character) values[1];
    labelWithAccessKey = (java.lang.String) values[2];
    jsfResource = (java.lang.Boolean) values[3];
    image = (java.lang.String) values[4];
    transition = (java.lang.Boolean) values[5];
    label = (java.lang.String) values[6];
    immediate = (java.lang.Boolean) values[7];
    disabled = (java.lang.Boolean) values[8];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[9];
    values[0] = super.saveState(context);
    values[1] = accessKey;
    values[2] = labelWithAccessKey;
    values[3] = jsfResource;
    values[4] = image;
    values[5] = transition;
    values[6] = label;
    values[7] = immediate;
    values[8] = disabled;
    return values;
  }


}